package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description :
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-10-23 15:53
 * @Modify:
 **/
public class WmsEnumUtil {
    /**
     * 订单明细信息 是否免费
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum IS_FREE {
        CHARGING(1, "计费"), GRATIS(2, "免费");

        private int value;
        private String description;

        IS_FREE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 订单明细信息 状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_DETAILS_STATUS {
        NORMAL(1, "N", "正常"),
        ANCEL(10, "C", "行取消"),
        RECEIPTED(20, "R", "已收货");

        private int value;
        private String code;
        private String description;

        ORDER_DETAILS_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 主表信息 单据来源
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_SRC {
        MNU(1, "MNU", "手工"),
        ERP(2, "ERP", "ERP接口");

        private int value;
        private String code;
        private String description;

        ORDER_SRC(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 主表信息 单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_TYPE {
        REG(1, "REG", "原物料采购"),
        SUB(10, "SUB", "委外采购"),
        TAR(20, "TAR", "多角贸易采购"),
        TAP(30, "TAP", "多角代采购");

        private int value;
        private String code;
        private String description;

        ORDER_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 主表信息 状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_STATUS {
        CREATE(1, "新建"),
        RECEIPT(10, "收货中"),
        RECEIPT_FINISH(20, "收货完成"),
        WAREHOUSING(30, "入库中"),
        WAREHOUSING_FINISH(40, "入库完成"),
        CLOSED(90, "已关闭"),
        CANCELLED(91, "已取消");

        private int value;
        private String description;

        ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 交易状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TRANS_STATUS {
        CREATE(1, "创建"), FINISH(2, "完成"), FAIL(3, "失败");

        private int value;
        private String description;

        TRANS_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }


    /**
     * 消息队列，队列名称
     * 1: success_queue
     * 2: fail_queue
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QUEUE_NAME {

        SUCCESS_QUEUE(1, "wms_success_queue", "成功消息队列"),
        FAIL_QUEUE(2, "wms_fail_queue", "成功消息队列");

        private int value;
        private String name;
        private String description;

        QUEUE_NAME(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 产品入库的产品状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PRODUCT_INSTOCK_STATUS {
        CREATE(10, "创建"), FINISH(20, "已处理"), FAIL(30, "处理出错");

        private int value;
        private String description;

        PRODUCT_INSTOCK_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 库位类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum LOCATE_TYPE {
        COLLECT_LOCATE(10, "I", "收货库"),
        BASICS_LOCATE(20, "P", "基础库"),
        MANEUVER_LOCATE(30, "R", "机动库"),
        COMBINATION_LOCATE(40, "D", "组合库"),
        LINE_LOCATE(50, "L", "线边库"),
        NC_LOCATE(60, "N", "NC库");

        private int value;
        private String code;
        private String description;

        LOCATE_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单移动类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_MOVE_TYPE {
        IN_STORE(1, "IN", "入库"),
        OUT_STORE(10, "OUT", "出库"),
        MOVE_STORE(20, "MOVE", "移库");

        private int value;
        private String code;
        private String description;

        OUT_MOVEMENT_MOVE_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 移库单业务类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_BUSI_TYPE {
        RECEIVE_GOODS(1, "RC", "收货"),
        QUALITY_TESTING(10, "QC", "质检"),
        IN_STORE(20, "IN", "入库"),
        MIX_RECEIVE(30, "ZI", "杂收"),
        MIX_SEND(40, "ZO", "杂发"),
        SUPPLIER_RETURN_GOODS(50, "VJ", "供应商退货"),
        CUSTOMER_RETURN_GOODS(60, "CJ", "客户退货"),
        ORDER_PICKING_PART(70, "WP", "工单领料"),
        ORDER_RETURN_PART(80, "WJ", "工单退料"),
        MOVE_IN(90, "MI", "移库入库"),
        MOVE_OUT(100, "MO", "移库出库"),
        SEND(110, "SO", "发运");

        private int value;
        private String code;
        private String description;

        OUT_MOVEMENT_BUSI_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_STATUS {
        CREATE(1, "新建"),
        RECEIPT(10, "处理中"),
        RECEIPT_FINISH(20, "已完成"),
        CLOSED(90, "已关闭"),
        CANCELLED(91, "已取消");

        private int value;
        private String description;

        OUT_MOVEMENT_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单详情单位
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_DETAILS_UNIT {
        CREATE(1, "AA"),
        RECEIPT(2, "BB"),
        RECEIPT_FINISH(3, "CC"),
        CLOSED(4, "DD"),
        CANCELLED(5, "EE");

        private int value;
        private String description;

        OUT_MOVEMENT_DETAILS_UNIT(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单详情状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_DETAILS_STATUS {
        NORMAL(1, "N", "正常"),
        CANCEL(2, "C", "取消");

        private int value;
        private String code;
        private String description;

        OUT_MOVEMENT_DETAILS_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 物料：分类（ABC）
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PART_ABC {
        A(1, "A"),
        B(2, "B"),
        C(3, "C"),
        D(4, "D"),
        E(5, "E");

        private int value;
        private String description;

        PART_ABC(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_MASTER_ORDER_TYPE {
        ORDER_PULL_PART(1, "工单配料");

        private int value;
        private String description;

        OUT_MOVEMENT_MASTER_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单关联单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_MASTER_LINK_ORDER_TYPE {
        ASN(1, "ASN"),
        PO(10, "PO"),
        SO(20, "SO");

        private int value;
        private String description;

        OUT_MOVEMENT_MASTER_LINK_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 作业任务状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TASK_INFO_STATUS {
        CREATE(10, "创建"), FINISH(20, "待处理"), FAIL(30, "已处理");

        private int value;
        private String description;

        TASK_INFO_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 业务表：库存条码状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum STOCK_SN_STATUS {
        CREATE(1, "创建"),
        RECEIVED(10, "已收货"),
        QUALITY_TESTED(20, "已质检"),
        PUTIN_STORE(30, "已入库"),
        WAIT_OUT_STORE(40, "待出库"),
        IS_OUT_STORE(50, "已出库"),
        ON_THE_WAY(60, "在途"),
        QUARANTINED(70, "已隔离"),
        BREAK_BUG(80, "破包"),
        FROZEN(90, "冻结"),
        CANCEL(100, "作废");

        private int value;
        private String description;

        STOCK_SN_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 业务表：库存条码质检状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum STOCK_SN_QC_STATUS {
        CREATE(1, "未质检"),
        RECEIVED(10, "质检合格"),
        QUALITY_TESTED(20, "质检不合格"),
        PUTIN_STORE(30, "已退货");

        private int value;
        private String description;

        STOCK_SN_QC_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点主表 单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum CS_ORDER_TYPE {
        DAY_INVENTORY(10, "日常盘点"),
        MONTH_INVENTORY(20, "月度盘点"),
        SEASON_INVENTORY(30, "季度盘点"),
        YEAR_INVENTORY(40, "年度盘点");

        private int value;
        private String description;

        CS_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点主表 盘点状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum CS_ORDER_STATUS {
        CREATE(1, "创建"),
        FROZEN(10, "已冻结"),
        IN_INVENTORY(20, "盘点中"),
        INVENTORY_FINISH(30, "盘点完成"),
        THAWING(40, "已解冻"),
        CLOSED(50, "已关闭");

        private int value;
        private String description;

        CS_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点冻结 质检状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QC_STATUS {
        NO_QC(1, "未质检"),
        IN_QC(10, "质检中"),
        QUALIFIED_QC(20, "质检合格"),
        DISQUALIFIED_QC(30, "质检不合格"),
        RETURN_GOODS(40, "已退货");

        private int value;
        private String description;

        QC_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点冻结 条码状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum SN_STATUS {
        CREATE(1, "创建"),
        RECEIVE_GOODS(10, "已收货"),
        QUALITY_TESTING(20, "已质检"),
        IN_STORE(30, "已入库"),
        WAIT_STORE(40, "待出库"),
        OUT_STORE(50, "已出库"),
        ON_PASSAGE(60, "在途"),
        QUARANTINE(70, "已隔离"),
        BALE_BROKEN(80, "破包"),
        FROZEN(90, "冻结"),
        RETURN_GOODS(100, "取消冻结");

        private int value;
        private String description;

        SN_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点冻结 处理状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum CS_TRANS_STATUS {
        CREATE(1, "已创建"),
        INVENTORY(5, "已盘"),
        FROZEN(10, "已冻结"),
        THAWING(20, "已解冻"),
        RETURN_GOODS(30, "取消冻结");

        private int value;
        private String description;

        CS_TRANS_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点实盘 处理状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum CS_ITEM_STATUS {
        CREATE(1, "创建"),FINISH(10, "已处理");

        private int value;
        private String description;

        CS_ITEM_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 库存移动单状态 状态:1=创建,10=待处理,20=已处理
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum MOVE_ORDER_STATUS {
        CREATE(1, "创建"),BE_HANDLE(10, "待处理"),FINISH(20, "已处理");

        private int value;
        private String description;

        MOVE_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }


    /**
     * 质检业务类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QC_INFO_TYPE {
        FEED(1, "进料检验"), ONLINE(10, "在线检验"), EMDPRODUCT(30, "成品检验"), SHIPMENTS(40, "出货检验");

        private int value;
        private String description;

        QC_INFO_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 质检业务状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QC_INFO_STATUS {
        CREATE(1, "创建"),
        FINISH(5, "待处理"),
        FAIL(10, "已完成"),
        CLOSE(90, "已关闭"),
        CANCEL(91, "已取消");

        private int value;
        private String description;

        QC_INFO_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 质检明细转态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QC_ITEM_STATUS {
        NORMAL(1, "正常"),
        CANCELLATION(10, "行取消");

        private int value;
        private String description;

        QC_ITEM_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 作业记录参数状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALD_EXECUTE_STATUS {
        NORMAL(1, "创建"),
        PROCESSING(10, "处理中"),
        COMPLETED(20, "已完成");
        private int value;
        private String description;

        ALD_EXECUTE_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 是否
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TRUE_OR_FALSE {
        CHARGING(1, "是"), GRATIS(2, "否");

        private int value;
        private String description;

        TRUE_OR_FALSE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 作业流程动作类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ACTION_GROUP_DETAILS_VALUE_TYPE {
        ONETIMEONLY(10, "只输入一次"),
        MANYTIME(20, "输入多次"),
        MAYTIMEUNIQUE(30, "输入多次不允许重复"),
        ACTIONFINISH(40, "本流程结束");

        private int value;
        private String description;

        ACTION_GROUP_DETAILS_VALUE_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 作业步骤处理组件参数类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ACTION_MOUDULE_PARAM_TYPE {
        CHECKLIST(1, "可选列表"),
        NUMBER(10, "数字"),
        STRING(20, "字符串"),
        OUT_OR_UNNECESSARY(30, "出参或者不必需的参数");

        private int value;
        private String description;

        ACTION_MOUDULE_PARAM_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 组件扫描单号 单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum RC_ORDER_TYPE {
        PO(10, "PO"),
        ASN(20, "ASN");

        private int value;
        private String description;

        RC_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 组件统一返回提示
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum RC_RESPONSE_TIPS {

        OK(1, true, "正确"),
        NG(2, false, "失败");

        private int value;
        private boolean codeStatus;
        private String description;

        RC_RESPONSE_TIPS(int value, boolean codeStatus, String description) {
            this.value = value;
            this.codeStatus = codeStatus;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public boolean getCodeStatus() {
            return codeStatus;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 流程管家中触发源
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ACTION_BUTLER_SOURCE {

        SCANNER(10, "扫描枪"),
        SUBMIT(20, "提交按钮"),
        RESET(30, "重置按钮"),
        CHECK_DETAILS(40, "查看明细"),
        DELETE_DETAILS(50, "明细(删除)"),
        CLEAR_DETAILS(60, "明细（清空）"),
        CUSTOM_BUTTON(70, "自定义按钮");

        private int value;
        private String description;

        ACTION_BUTLER_SOURCE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * PO条码表条码状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PO_SN_STATUS {

        FOUND(10, "创建"),
        PRINTED(20, "已打印"),
        RECEIPTED(30, "已收货");

        private int value;
        private String description;

        PO_SN_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 组件类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum COMPONENT_TYPE {

        PROCESS_HANDLING(10, "流程处理组件,"),
        PROCESS_INITIALIZATION(20, "流程初始化组件"),
        PROCESS_END(30, "流程结束组件"),
        DETAIL_PROCESS(40, "明细处理组件"),
        BACK_DISPLAY(50, "回显示组件");

        private int value;
        private String description;

        COMPONENT_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 作业步骤处理组件类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ACTION_MODULE_TYPE {
        HANDLE(10, "流程处理组件"),
        INIT(20, "流程初始化组件"),
        END(30, "流程结束组件"),
        DETAILS(40, "明细处理组件"),
        SHOW(50, "回显示组件");

        private int value;
        private String description;

        ACTION_MODULE_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 条码类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum SN_TYPE {
        ONE_DIMENSIONAL_CODE(10, "1D"),
        QR_CODE(20, "2D"),
        ALL(30, "ALL");

        private int value;
        private String description;

        SN_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }
    /**
     * 流程明细动作类型
     *  10=交互动作,20=后台动作,30=提交动作
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum GROUP_VALUE_TYPE {

        INTERACTIVE_ACTION(10, "交互动作"),
        BACKSTAGE_ACTION(20, "后台动作"),
        SUBMIT_ACTION(30, "提交动作"),
        SELECT_ACTION(40, "选择动作");

        private int value;
        private String description;

        GROUP_VALUE_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 成功标志枚举
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum RC_OK_VALUE {

        IS_TRUE(10, true, "成功"),
        IS_FALSE(20, false, "失败");

        private int value;
        private boolean codeValue;
        private String description;

        RC_OK_VALUE(int value, boolean codeValue, String description) {
            this.value = value;
            this.codeValue = codeValue;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public boolean getCodeValue() {
            return codeValue;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 通用序号编码枚举
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum COMMON_SEQ {
        TASK_MV_ORDERNO("TASK_MV_ORDERNO", "作业任务移动单号"),
        ROUTING_SEQ("ROUTING_SEQ", "物料路线序号"),
        LOCATE_SEQ("LOCATE_SEQ", "库位序号"),
        OP_SEQ("OP_SEQ", "作业类型序号"),
        TRAN_SEQ("TRAN_SEQ", "交易类型序号"),
        STEP_SEQ("STEP_SEQ", "步骤调用序号"),
        ORDER_NO("ORDER_NO", "盘点主表序号");

        private String code;
        private String description;
        int value;

        COMMON_SEQ(String code, String description) {
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 可选项类型枚举
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OPTION_TYPE {
        OPTIONS(10, "OPTIONS", "可选项"),
        BUTTON(20, "BUTTON", "按钮");

        private String code;
        private String description;
        int value;

        OPTION_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }
    }


}
