package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * @Description : 元素和报表关联表，多对多
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-25 19:54
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_REF_REPORT_ELEMENT")
@Api(value="元素&报表",description = "元素和报表的关联表 * -》 *")
public class BrRefReportElement extends BaseBean {

    @Column(name = "REPORT_ID")
    @ApiParam(value = "报表主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long reportId;

    @Column(name = "REPORT_NAME_RDD")
    @ApiParam(value = "报表名称")
    private String reportNameRdd;

    @Column(name = "LAYOUT_COLUMN_ID")
    @ApiParam(value = "列主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long layoutColumnId;

    @Column(name = "ELEMENT_ID")
    @ApiParam(value = "元素主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long elementId;

    @Column(name = "ELEMENT_NAME_RDD")
    @ApiParam(value = "元素名称")
    private String elementNameRdd;

    @Column(name = "ELEMENT_HTML_RDD",columnDefinition = "TEXT")
    @ApiParam(value = "元素html")
    @JsonSerialize(using = ToStringSerializer.class)
    private String elementHtmlRdd;

    @Transient
    @ApiParam(value = "报表实例")
    private BrReport brReport;

    @Transient
    @ApiParam(value = "报表元素")
    private BrElement brElement;
}