package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 * @Description : 报表模板和报表关联表，多对多
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-25 19:54
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_REF_REPORT_TEMPLATE")
@Api(value="报表模板&报表",description = "报表模板和报表的关联表 * -》 *")
public class BrRefReportTemplate extends BaseBean {

    @Column(name="REPORT_ID")
    @ApiParam(value ="报表主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long reportId;

    @Column(name = "REPORT_NAME_RDD")
    @ApiParam(value = "报表名称")
    private String reportNameRdd;

    @Column(name="LAYOUT_COLUMN_ID")
    @ApiParam(value ="列主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long layoutColumnId;

    @Column(name="REPORT_TEMPLATE_ID")
    @ApiParam(value ="报表模板主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long reportTemplateId;

    @Column(name="REPORT_TEMPLATE_NAME_RDD")
    @ApiParam(value ="报表模板名称")
    private String reportTemplateNameRdd;

    @Column(name="REPORT_TEMPLATE_HTML_RDD")
    @ApiParam(value ="报表模板html")
    private String reportTemplateHtmlRdd;

    @Transient
    @ApiParam(value = "报表模板")
    private BrReportTemplate brReportTemplate;
}
