package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 报表实例
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-25 19:54
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_REPORT")
@Api(value="自定义报表",description = "所有报表实例，生成最后的报表")
public class BrReport extends BaseBean {

    @Column(name="REPORT_NAME")
    @ApiParam(value ="报表名称")
    private String reportName;

    @Column(name="LAYOUT_ID")
    @ApiParam(value ="布局主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long layoutId;

    @Column(name="LAYOUT_ID_RDD")
    @ApiParam(value ="布局名称")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long layoutNameRdd;

    @Column(name="LAYOUT_HTML")
    @ApiParam(value ="布局html")
    private String reportHtml;

    @Column(name="SEQ")
    @ApiParam(value ="排序")
    private Integer seq;
}
